unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    radius_a_Edit: TLabeledEdit;
    radius_b_edit: TLabeledEdit;
    arc_degree_edit: TLabeledEdit;
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    k_Edit: TLabeledEdit;
    CheckBox1: TCheckBox;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses system.Math, System.VarCmplx, mp_real, mp_cmplx, mp_types, mp_base;

var
  LDBL_EPSILON: double;

// f\
type
  TCdouble = record
    r : double;
    i : double;
  end;

// fϊ  Varint to TCdouble
function VtoT(x : variant): TCdouble;
begin
  result.r := x.real;
  result.i := x.Imaginary;
end;

// fϊ  TCdouble to variant;
function TtoV(x : TCdouble): variant;
begin
  result := varascomplex(result);
  result.real := x.r;
  result.Imaginary := x.i;
end;

// TCdoublef̏Z
function cdiv(a, b: TCdouble): TCdouble;
var
  bb: double;
begin
  result.r := 0;
  result.i := 0;
  bb := b.r * b.r + b.i * b.i;
  if bb <> 0 then begin
    result.r := (a.r * b.r + a.i * b.i) / bb;
    result.i := (a.i * b.r - a.r * b.i) / bb;
  end;
end;

// f̐
function Varcomplex(a, b: double): Variant;
begin
  result := varascomplex(result);
  result.real := a;
  result.Imaginary := b;
end;

//--------------------------------------------------------------------------------------------------
// PQsSȉ~ϕ  Large_Modulus_prus_complex p
// FBnKn[0] Pȉ~ϕ
// EBnKn[0] Qȉ~ϕ
// fϊ
// Q px rad
// m = k^2
// ̒lKvȂ̂ŕf̌vZ܂B
// ̃[`fϊłAtaňvZ炢̂ō̗pĂ܂B
// 90(pi/2)ȏ90vZKvłB
//--------------------------------------------------------------------------------------------------
function second_imperfect_elliptic_integral(Q, m: variant; var F, E: variant): integer;
var
  I, MI   : integer;
  k       : double;
  Kn      : array of double;          // Kn
  knd     : array of variant;         // k'n
  N2SKn   : array of variant;         // 2/(1+Kn)
  T2SKnd  : array of variant;         // P2/(1+Kn')
  BRad    : array of variant;         // (rad)
  SinBn   : array of variant;         // sinn
  FBnKn   : array of variant;         // F(n,kn)
  EBnKn   : array of variant;         // E(n,kn)
  mtmp0, mtmp1  : mp_complex;
  tmp0          : variant;
  LnD           : variant;
  mpt0, mpt1    : TCdouble;
begin
  mpc_init2(mtmp0, mtmp1);

  k := sqrt(m.real);

  MI := 0;
  LND := 0;
  setlength(kn,  MI + 1);           // kn
  kn[0] := K;
  while LND <> Kn[MI] do begin
    LnD := Kn[MI];
    inc(MI);
    setlength(kn,  MI + 1);         // kn
    kn[MI] := 2 * sqrt(Kn[MI - 1])/(1 + Kn[MI - 1]);
  end;
  Dec(MI);
  setlength(kn,      MI + 1);         // kn
  setlength(knd,     MI + 1);         // k'n
  setlength(N2SKn,   MI + 1);         // 2/(1+Kn)
  setlength(T2SKnd,  MI + 1);         // P2/(1+Kn')
  setlength(BRad,    MI + 1);         // (rad)
  setlength(SinBn,   MI + 1);         // sinn
  setlength(FBnKn,   MI + 1);         // F(n,kn)
  setlength(EBnKn,   MI + 1);         // E(n,kn)

  knd[0] := Varcomplex(1, 0);
  for I := 1 to MI do
    knd[I] := Varcomplex((1 - kn[I - 1]) / (1 + Kn[I - 1]), 0);
  for I := 0 to MI do
    N2SKn[I] := Varcomplex(2 / (1 + kn[I]), 0);
  T2SKnd[MI] := N2SKn[MI];
  for I := MI - 1 downto 0 do
    T2SKnd[I] := T2SKnd[I + 1] * N2SKn[I];
  BRad[0] := Q;
  for I := 1 to MI do
    BRad[I] := (Varcomplexarcsin(kn[I - 1] * Varcomplexsin(Brad[I - 1])) + Brad[I - 1]) / 2;
  for I := 0 to MI do
    SinBn[I] := Varcomplexsin(Brad[I]);

  // [ŏZh~ Varcomplexcos(Brad[MI]) Ɛϕpx270Ōɂ 0 ɂȂ܂
  mpc_set_dbl(mtmp0, Brad[MI].real, Brad[MI].Imaginary);  // variant -> mpc
  mpc_cos(mtmp0, mtmp1);                                  // {fcos
  mpt0.r := mpf_todouble(mtmp1.re);                       // mpc.re -> TCdouble.r
  mpt0.i := mpf_todouble(mtmp1.im);                       // mpc.im -> TCdouble.i
  tmp0 := 1 + Varcomplexsin(Brad[MI]);

  mpt1 := VtoT(tmp0);                     // variant -> TCdouble
  mpt0 := cdiv(mpt1, mpt0);               // (1 + Varcomplexsin(Brad[MI])) / Varcomplexcos(Brad[MI]);
  mpc_set_dbl(mtmp0, mpt0.r, mpt0.i);     // TCdouble -> mpc_complex
  mpc_ln(mtmp0, mtmp1);                   // ln((1+sin(Brad[MI]))/ cos(brad[MI])
  Lnd := Varcomplex(0, 0);
  LnD.real := mpf_todouble(mtmp1.re);     // mpc_coplex->variant
  LnD.Imaginary := mpf_todouble(mtmp1.im);

  for I := 0 to MI do
    FBnKn[I] := T2SKnd[I] * LnD;
  F := FBnKn[0];

  mpc_set_dbl(mtmp0, Brad[MI].real, Brad[MI].Imaginary);  // variant -> mpc
  mpc_sin(mtmp0, mtmp1);                                  // {fsin
  EBnKn[MI] := Varcomplex(0, 0);
  EBnKn[MI].real := mpf_todouble(mtmp1.re);
  EBnKn[MI].Imaginary := mpf_todouble(mtmp1.im);
  //  EBnKn[MI] := Varcomplexsin(Brad[MI]);

  for I := MI - 1 downto 0 do
    EBnKn[I] :=  (2 * EBnKn[I + 1] + 2 * knd[I + 1] * FBnKn[I + 1]) / (1 + knd[I + 1]) - kn[I] * SinBn[I];
  E := EBnKn[0];
  result := MI + 1;

  mpc_clear2(mtmp0, mtmp1);
end;

//--------------------------------------------------------------------------------------------------
// S ̒l jP̏ꍇ̕fvZB
// pxpx90vZB
// 񕪊ł̌vZsB
// S̒lP𒴂ƁAoȐƂȂ苕܂B
//--------------------------------------------------------------------------------------------------
function Large_Modulus_prus_complex(phi, ki: variant; var F, E: variant): integer;
var
  one     : variant;
  m       : variant;
  sin_phi : variant;
  Fk, Ek  : variant;
  n, nn   : integer;
  signphi : integer;
  signp   : integer;
  mm      : variant;
  phib    : variant;
  pai     : double;
  l1, l2  : integer;
begin
  m       := varascomplex(m);
  mm      := varascomplex(mm);
  sin_phi := varascomplex(sin_phi);
  one     := Varcomplex(1, 0);                      // one = 1 + 0i
  pai     := PI;                                    // extended -> double;
  signphi := sign(phi.real);                        // px̕擾
  m       := ki * ki;                               // m = k^2
// ی̐ϕ
  phi.real := abs(phi.real);                        // px̐Βl
  n       := trunc((phi.real + pai / 2 ) / pai);    // ϕpx 90x̔{
  phi     := phi - n * pai;                         // ی̐ϕpx
  signp   := sign(phi.real);
  sin_phi := VarComplexSin(phi);                    // sin(ی̐ϕpx)
  phi     := VarComplexarcsin(ki * sin_phi);        // Sk>1ɂdی̐ϕp
  nn      := n + n;                                 // nn = 2n
  mm      := VarComplexInverse(m);                  // mm := 1/m
//  pai := VarComplexAngle(phi);                      // fʊpx
//  Form1.Memo1.Lines.Append('fʊpx = ' + floatTostr(pai / pi * 180));
  if phi.real < 0 then phi := -phi;                 // phi.real > 0  ɐݒ
  l1 := second_imperfect_elliptic_integral(phi, mm, F, E);  // fϊϕ
// 90̐ϕ
  phib    := varcomplex(pai / 2, 0 );               // ϕpx90
  sin_phi := varcomplexsin(phib);
  phib     := VarComplexarcsin(ki * sin_phi);       // S k@> 1 ɂ̐ϕp
  l2 := second_imperfect_elliptic_integral(phib, mm, Fk, Ek);  // fϊϕ90
  EK := ki * EK + (one - m) * FK / Ki;
  E  := ki * E + (one - m) * F / Ki;
// یɂvZ
  if signp > 0 then begin
    F := F + nn * FK;
    E := E + nn * EK;
  end
  else begin
    F := nn * FK - F;
    E := nn * EK - E;
  end;
  F := F / ki;

  E := E * signphi;                                 // ϕpx̕ŕݒ
  F := F * signphi;
  result := max(l1, l2);                            // [v
end;

//--------------------------------------------------------------------------------------------------
// fϊȉ~ϕ   S@sS vZ
// m < 1
// ȉ~ϕƊSƕsSϕɍsȂ܂B
// ϕpx̏͂܂B
//--------------------------------------------------------------------------------------------------
function Landen_Transform(phi, parameter: double; var F, Fk, E, Ek: double): integer;
var
  two_n: double;
  a, g, a_old, g_old: double;
  tan_2n_phi, sum, integral: double;
  n : integer;
begin
  two_n := 1.0;
  a := 1.0;
  g := sqrt(1.0 - parameter);
  sum := 2.0 * (2.0 - parameter);
  integral := 0.0;
  n := 0;
  repeat
    tan_2n_phi := tan(two_n * phi);                   // tan(90) = -3.68934 E19 ɂȂ܂
    sum := sum - two_n * (a - g) * (a - g);
    two_n := two_n + two_n;
    phi := phi - arctan((a - g) * tan_2n_phi / (a + g * tan_2n_phi * tan_2n_phi)) / two_n;
    integral := integral + (a - g) * sin(two_n * phi);
    g_old := g;
    a_old := a;
    a := (g_old + a_old) / 2;
    g := sqrt(g_old * a_old);
    inc(n);
  until (abs(a_old - g_old) <= (a_old * LDBL_EPSILON));
  F := phi / g;
  Fk := PI / 2 / g;
  E :=  1 / 2 * integral + 1 / 4 * sum * phi / g;
  Ek := PI / 8 / a * sum;
  result := n;
end;
//--------------------------------------------------------------------------------------------------

// p[^̒l}CiX̎̃Tu[`90vZ@vZB
function Elliptic_Integrals(phi, m: double; var F, Fk, E, Ek: double): integer;
var
  n: integer;
  pai, pis2: double;
begin
  pai := PI;
  pis2 := PI / 2;
  n := trunc((phi + pis2) / pai);
  phi := phi - n * pai;
  n := n + n;
  result := Landen_Transform(abs(phi), m, F, Fk, E, Ek);
  if phi >= 0.0 then begin
    F := F +  n * Fk;
    E := E +  n * Ek;
  end
  else begin
    F := n * Fk - F;
    E := n * EK - E;
  end;
end;

//--------------------------------------------------------------------------------------------------
// p[^̒lO̎̌vZB
// p[^̒lvXɕϊČvZ܂B
// ͕fł[Ȃ̂ŎvZ܂B
//--------------------------------------------------------------------------------------------------
function Elliptic_Integral_minus_m(phiin, min: variant; var Fin, Ein : variant): integer;
var
  F, E: double;
  K, EK : double;
  dum   : double;
  signphi : double;
  phi, m : double;
  i : integer;
begin
  phi := phiin.real;
  m   := min.real;
  signphi := sign(phi);
  phi := PI / 2 - abs(phi);

  dum := sqrt(1.0 - m);

  i := Elliptic_Integrals(phi, abs(m / (1.0 - m)), F, K, E, Ek);
  F := signphi * (K - F) / dum;
  E := signphi * (EK - E) * dum;
  Fin.real := F;
  Ein.real := E;
  result := i;
end;

//--------------------------------------------------------------------------------------------------
// p[^̒l 0 <  <P̎̌vZB
// ʓIȒľvZłB
// P̎̓fϊϕvZ͂܂B
// ͕fłA[Ȃ̂ŎvZ܂B
//--------------------------------------------------------------------------------------------------
function Elliptic_Integral_FS(phiin, min: variant; var Fin, Ein : variant): integer;
var
  F, E: double;
  n, i: integer;
  K, Ek, m, phi: double;
begin
  phi := phiin.real;
  m := min.real;
  if  m = 1 then begin
    if abs(phi) >= PI / 2 then begin
      F := infinity;
      if phi < 0 then F := -F;
    end
    else begin
      K := tan(Phi);
      F := sign(Phi) * ln(abs(K) + sqrt(1.0 + K * K));
    end;
    if (abs(phi) <= PI / 2) then begin
      E := sin(phi);
    end
    else begin
      n := trunc((abs(phi) + PI / 2) / PI);
      E := n + n + sin(abs(phi) - n * PI);
      if phi < 0 then E := - E;
    end;
    Fin.real := F;
    Ein.real := E;

    result := 0;
    exit;
  end;

// 90vZ
  n := trunc((phi + PI / 2) / PI);
  phi := phi - n * PI;
  n := n + n;
  i := Landen_Transform(abs(phi), m, F, K, E, Ek);
  F := sign(phi) * F + n * K;
  E := sign(phi) * E  + n * Ek;
  Fin.real := F;
  Ein.real := E;
  result := i;
end;
//--------------------------------------------------------------------------------------------------

//--------------------------------------------------------------------------------------------------
// ȉ~̔a@邢 Sȉ~ϕvZ܂B
// Sk̒lƂċ͉\̖ɂtłB
// k̒lɓ͐͂܂B
//--------------------------------------------------------------------------------------------------
procedure TForm1.BitBtn1Click(Sender: TObject);
var
  ch, l         : integer;
  a, b, deg     : double;
  q, k, m, degb : double;
  ac, bc        : variant;
  kc, mc, qc    : variant;

  F, E          : variant;
  kstr, kss     : string;
  c             : char;
  kssF          : boolean;
  degmax, kmax  : double;
  pai           : double;
begin
  val(radius_a_edit.Text, a, ch);
  if ch <> 0 then begin
    application.MessageBox('aa̒lɊԈႢ܂B','',0);
    exit;
  end;
  if a <= 0 then begin
    application.MessageBox('aa̒l͂O傫ĉB','',0);
    exit;
  end;
  val(radius_b_edit.Text, b, ch);
  if ch <> 0 then begin
    application.MessageBox('ab̒lɊԈႢ܂B','',0);
    exit;
  end;
  if b < 0 then begin
    application.MessageBox('a̒l͂OȏɂĉB','',0);
    exit;
  end;
  val(arc_degree_edit.Text, deg, ch);
  if ch <> 0 then begin
    application.MessageBox('ϕ͈̔̓̒lɊԈႢ܂B','',0);
    exit;
  end;
  if abs(deg) > 360 then begin
    application.MessageBox('ϕ͈̔̓̒ĺ}360ȉɂĉB','',0);
    exit;
  end;
  kssF := false;
  if checkbox1.Checked then begin                 // S k wȂ
    kstr := k_edit.Text;
    if kstr = '' then begin
      application.MessageBox('Sk̒l܂B','',0);
      exit;
    end;
    l       := length(kstr);                      // ̒擾
    c       := kstr[l];                           // i̕mF
    if (c = 'i') or (c = 'I') then begin          // iw肾
      kssF  := True;                              // tOZbg
      kss   := copy(kstr, 1,  l - 1);             // ȋO܂ŃRs[
    end
    else Kss := kstr;
    val(Kss, k, ch);
    if ch <> 0 then begin
      application.MessageBox('Sk̒lɊԈႢ܂B','',0);
      exit;
    end;
    m       := k * k;
    if kssF then m := -m;                         //  m = -m
  end
  else begin                                      // S k włȂȂ kvZ
    m       := 1 - b * b / a / a;                 // m = (a^2-b^2)/a^2  k = m
    k       := sqrt(abs(m));                      // k̐Βl \p
    if m >= 0 then
      k_edit.Text := floatTostr(k)
    else
      k_edit.Text := floatTostr(k) + 'i';
  end;
  memo1.Clear;
  pai := pi;                                      // pi extended => pai double
  degb := deg;                                    // CO̒lۑ
  q := deg / 180 * pai;                           // pxradϊ

  F   := varcomplex(0, 0);
  E   := varcomplex(0 ,0);

  ac  := Varcomplex(a, 0);                        // fɓ͒lZbg
  bc  := Varcomplex(b, 0);
  qc  := Varcomplex(q, 0);
  if checkbox1.Checked then                       // S k wȂ
    mc := Varcomplex(m, 0)                        // ͒lm=ki^2 Zbg
  else
    mc := (VarComplexSqr(ac) -VarComplexSqr(bc)) / VarComplexSqr(ac); // a,b̒lm̌vZ
  kc  := VarComplexSqrt(mc);                      // k = m

  if m > 1 then begin                             // k > 1   m > 1
    ch := Large_Modulus_prus_complex(qc, kc, F, E);         // k m P傫ꍇ̌vZ

    degmax := arcsin(sqrt(1 / (k * k))) / pi * 180;
    if abs(degb) < 90 then kmax := sin(abs(degb) / 180 * pi)
                      else kmax := 1;
    if kmax <> 0 then begin
      kmax := sqrt(1 / (kmax * kmax));
      Form1.Memo1.Lines.Append('SŒ̊px̍ől }' + floatTostr(degmax) + 'deg');
      Form1.Memo1.Lines.Append('pxŒ̗S̍ől @' + floatTostr(kmax));
    end;
  end
  else begin
    if m >= 0 then ch := Elliptic_Integral_FS(qc, mc, F, E);          // O
    if m < 0  then ch := Elliptic_Integral_minus_m(qc, mc, F, E);     //  O
  end;
  Memo1.Lines.Append('@Loop  ' + inttostr(ch));
  Memo1.Lines.Append('@P@@' + floatTostr(F.real));
  Memo1.Lines.Append('@                  @@ ' + floatTostr(F.Imaginary) + 'i');
  Memo1.Lines.Append('@Q@@' + floatTostr(E.real));
  Memo1.Lines.Append('@@@@@@@@@@@@ ' + floatTostr(E.Imaginary) + 'i');
end;

// l LDBL_EPSILON̐ݒ
procedure TForm1.FormCreate(Sender: TObject);
var
  one, tmp: double;
begin
  one := 1;
  LDBL_EPSILON := one;
  repeat
    LDBL_EPSILON := LDBL_EPSILON / 2;
    tmp := LDBL_EPSILON + one;
  until tmp = one;
  LDBL_EPSILON := LDBL_EPSILON * 2;           // LDBL_EPSILON := 2^(1-32)
  memo1.Clear;
  memo1.Lines.Append('PAQȉ~ϕ');
end;

end.
