unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    parameter_k_Edit: TLabeledEdit;
    arc_degree_Edit: TLabeledEdit;
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    radius_a_Edit: TLabeledEdit;
    radius_b_Edit: TLabeledEdit;
    CheckBox1: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses system.Math;

var
  LDBL_EPSILON: extended;

//------------------------------------------------------------------------------

// fϊȉ~ϕ 
function Landen_Transform(phi, parameter: extended; var F, Fk, E, Ek: extended): integer;
var
  two_n: extended;
  a, g, a_old, g_old: extended;
  tan_2n_phi, sum, integral: extended;
  n : integer;
begin
  two_n := 1.0;
  a := 1.0;
  g := sqrt(1.0 - parameter);
  sum := 2.0 * (2.0 - parameter);
  integral := 0.0;
  n := 0;
  repeat
    tan_2n_phi := tan(two_n * phi);                   // tan(90) = -3.68934 E19 ɂȂ܂
    sum := sum - two_n * (a - g) * (a - g);
    two_n := two_n + two_n;
    phi := phi - arctan((a - g) * tan_2n_phi / (a + g * tan_2n_phi * tan_2n_phi)) / two_n;
    integral := integral + (a - g) * sin(two_n * phi);
    g_old := g;
    a_old := a;
    a := (g_old + a_old) / 2;
    g := sqrt(g_old * a_old);
    inc(n);
  until (abs(a_old - g_old) <= (a_old * LDBL_EPSILON));
  F := phi / g;
  Fk := PI / 2 / g;
  E :=  1 / 2 * integral + 1 / 4 * sum * phi / g;
  Ek := PI / 8 / a * sum;
  result := n;
end;
//------------------------------------------------------------------------------

// S̒lP傫ꍇ̌vZ
// łpx̍ől̂ŒӂKvłB
// GF tO true ŕȂvZ
// ͂܂
function Large_Modulus_prus(phi, ki: extended; var F, K, E, Ek: extended; GF: boolean): integer;
var
  m : extended;
  sin_phi: extended;
  n : integer;
  signphi : integer;
begin
  signphi := sign(phi);
  m := ki * ki;
  phi := abs(phi);
  n := trunc((phi + PI / 2 )/ PI);
  phi := phi - n * PI;
  n := n + n;
  sin_phi := sin(phi);
  if abs(sin_phi) >= 1.0 / ki then begin    // ϕ͈͂z90+ n * 90vZ
    if phi > 0.0 then phi := PI / 2         // ͌vZ܂
                 else phi := - PI/ 2;
  end
  else phi := arcsin(ki * sin_phi);
  if GF then begin
    result := Landen_Transform(abs(phi + n * pi / 2), 1 / m, F, K, E, Ek);
    E := E * ki + (1.0 - m) * F / ki;
    F := F / ki;
    E := E * signphi;
    F := F * signphi;
    exit;
  end;
  result := Landen_Transform(abs(phi), 1 / m, F, K, E, Ek);
  Ek := ki * Ek + (1.0 - m) * K / ki;
  E := ki * E + (1.0 - m) * F / ki;
  if phi >= 0.0 then begin
    F := F + n * K;
    E := E + n * Ek;
  end
  else begin
    F := n * K - F;
    E := n * Ek - E;
  end;
  F := F / ki * signphi;
  E := E * signphi;
end;

// S̒ljP̏ꍇ̌vZ
// ̏opxƗS\
procedure Large_Modulus_prus_k(phiin, kin: extended);
var
  F, E: extended;
  K, EK: extended;
  i: integer;
  degmax, kmax: extended;
begin
  degmax := arcsin(sqrt(1 / (kin * kin))) / pi * 180;
  kmax := sin(phiin);
  if kmax <> 0 then begin
    kmax := sqrt(1 / (kmax * kmax));
    Form1.Memo1.Lines.Append('SŒ̊px̍ől }' + floatTostr(degmax) + 'deg');
    Form1.Memo1.Lines.Append('pxŒ̗S̍ől @' + floatTostr(kmax));
  end;
  i := Large_Modulus_prus(phiin, kin, F, K, E, Ek, True);
  Form1.Memo1.Lines.Append('Landen Loop ' + intTostr(i));
  Form1.Memo1.Lines.Append('@P@@' + floatTostr(F));
  Form1.Memo1.Lines.Append('@Q@@' + floatTostr(E));

  i := Large_Modulus_prus(phiin, kin, F, K, E, Ek, False);
  Form1.Memo1.Lines.Append('Landen Loop ' + intTostr(i));
  Form1.Memo1.Lines.Append('@P@@@@' + floatTostr(F));
  Form1.Memo1.Lines.Append('@Q@@@@' + floatTostr(E));
end;
//------------------------------------------------------------------------------

// p[^m̒l}CiX̎̌vZ
// GF tO true ŕȂvZ
function Elliptic_Integrals(phi, m: extended; var F, K, E, Em: extended; GF: boolean): integer;
var
  n: integer;
  pai, pis2: extended;
begin
  if GF then begin
    result := Landen_Transform(abs(phi), m, F, K, E, Em);
    exit;
  end;
  pai := pi;
  pis2 := pi / 2;
  n := trunc((phi + pis2) / pai);
  phi := phi - n * pai;
  n := n + n;
  result := Landen_Transform(abs(phi), m, F, K, E, Em);
  if phi >= 0.0 then begin
    F := F +  n * K;
    E := E +  n * Em;
  end
  else begin
    F := n * K - F;
    E := n * Em - E;
  end;
end;

// p[^̒lO̎̌vZ
procedure Elliptic_Integral_minus_m(phiin, m: extended);
var
  F, E: extended;
  K, EK : extended;
  dum   : extended;
  signphi : extended;
  phi : extended;
  i : integer;
begin
  signphi := sign(phiin);
  phi := PI / 2 - abs(phiin);

  i := Elliptic_Integrals(phi, abs(m / (1.0 - m)), F, K, E, Ek, True);
  dum := sqrt(1.0 - m);
  if abs(phiin) > pi / 2 then begin
    F := signphi * (F + K) / dum;
    E := signphi * (E + EK) * dum;
  end
  else begin
    F := signphi * (K - F) / dum;
    E := signphi * (EK - E) * dum;
  end;
  K := K / dum;
  Ek:= Ek * dum;
  Form1.Memo1.Lines.Append('Landen Loop ' + intTostr(i));
  Form1.Memo1.Lines.Append('@P@@' + floatTostr(F));
  Form1.Memo1.Lines.Append('@Q@@' + floatTostr(E));

  i := Elliptic_Integrals(phi, abs(m / (1.0 - m)), F, K, E, Ek, False);
  Form1.Memo1.Lines.Append('Landen Loop ' + intTostr(i));
  F := signphi * (K - F) / dum;
  E := signphi * (EK - E) * dum;
  K := K / dum;
  Ek:= Ek * dum;
  Form1.Memo1.Lines.Append('@P@90@' + floatTostr(F));
  Form1.Memo1.Lines.Append('@Q@90@' + floatTostr(E));
end;
//------------------------------------------------------------------------------

// p[^̒l P̎̌vZ
procedure Elliptic_Integral_FS(phi, m: extended);
var
  n, i: integer;
  F, K, E, Ek: extended;
begin
  if  m = 1.0 then begin
    if abs(phi) >= PI / 2 then begin
      F := infinity;
      if phi < 0 then F := -F;
    end
    else begin
      K := tan(Phi);
      F := sign(Phi) * ln(abs(K) + sqrt(1.0 + K * K));
    end;
    if (abs(phi) <= PI / 2) then begin
      E := sin(phi);
    end
    else begin
      n := trunc((abs(phi) + PI / 2) / PI);
      E := n + n + sin(abs(phi) - n * PI);
      if phi < 0 then E := - E;
    end;
    K := infinity;
    EK := 1;
    Form1.Memo1.Lines.Append('@P@m = 1@' + floatTostr(F));
    Form1.Memo1.Lines.Append('@Q@m = 1@' + floatTostr(E));
    exit;
  end;

// vZ
  i := Landen_Transform(abs(phi), m, F, K, E, Ek);
  Form1.Memo1.Lines.Append('Landen Loop ' + intTostr(i));
  F := sign(phi) * F;
  E := sign(phi) * E;
  Form1.Memo1.Lines.Append('@P@@' + floatTostr(F));
  Form1.Memo1.Lines.Append('@Q@@' + floatTostr(E));

// 90vZ
  n := trunc((phi + PI / 2) / PI);
  phi := phi - n * PI;
  n := n + n;
  i := Landen_Transform(abs(phi), m, F, K, E, Ek);
  Form1.Memo1.Lines.Append('Landen Loop ' + intTostr(i));
  F := sign(phi) * F + n * K;
  E := sign(phi) * E  + n * Ek;
  Form1.Memo1.Lines.Append('@P@90@' + floatTostr(F));
  Form1.Memo1.Lines.Append('@Q@90@' + floatTostr(E));
end;
//------------------------------------------------------------------------------

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  kin, m      : extended;
  a, b        : extended;
  deg, phi    : extended;
  ch,l          : integer;
  kstr, kss   : string;
  c           : char;
  kssF        : boolean;
begin
  val(radius_a_edit.Text, a, ch);
  if ch <> 0 then begin
    application.MessageBox('aa̒lɊԈႢ܂B','',0);
    exit;
  end;
  if a <= 0 then begin
    application.MessageBox('aa̒l͂O傫ĉB','',0);
    exit;
  end;
  val(radius_b_edit.Text, b, ch);
  if ch <> 0 then begin
    application.MessageBox('ab̒lɊԈႢ܂B','',0);
    exit;
  end;
  if b < 0 then begin
    application.MessageBox('a̒l͂OȏɂĉB','',0);
    exit;
  end;
  val(arc_degree_edit.Text, deg, ch);
  if ch <> 0 then begin
    application.MessageBox('ϕ͈̔̓̒lɊԈႢ܂B','',0);
    exit;
  end;
  memo1.Clear;
  kssF := False;
  if checkbox1.Checked then begin                 // kwvZ
    kstr := parameter_k_edit.Text;
    if kstr = '' then begin
      application.MessageBox('Sk̒l܂B','',0);
      exit;
    end;
   l := length(kstr);                             // ̒
    c := kstr[l];                                 // Ō̕擾
    if (c = 'i') or (c = 'I') then begin          // i 狕
      kssF := True;                               // tOZbg
      kss := copy(kstr,1, l - 1);                 // ȋO܂ŃRs[
    end
    else Kss := kstr;
    val(Kss, kin, ch);
    if ch <> 0 then begin
      application.MessageBox('Sk̒lɊԈႢ܂B','',0);
      exit;
    end;
    m := kin * kin;                               // k^2
    if kssF then m := -m;                         // w肾m -> -m
  end
  else begin                                      // kwŖ
    m := 1 - b * b / a / a;                       // m = (a^2-b^2)/a^2  k = m
    kin := sqrt(abs(m));
    if m >= 0 then
      parameter_k_edit.Text := floatTostr(kin)
    else
      parameter_k_edit.Text := floatTostr(kin) + 'i';
  end;
  phi := deg / 180 * pi;
  if (m >= 0)  and (m <= 1) then begin            // 0 <= m <=1   -1 <= K <= 1
    Elliptic_Integral_FS(phi,m);
  end;
  if m < 0 then begin                             // m < 0        k > 0i
     Elliptic_Integral_minus_m(phi, m);
  end;
  if m > 1 then begin                             // m > 1     k > 1 or k < -1
    kin := sqrt(m);
    Large_Modulus_prus_k(phi, kin);
  end;
end;
//------------------------------------------------------------------------------

// ݒ
procedure TForm1.FormCreate(Sender: TObject);
var
  one, tmp: extended;
begin
  one := 1;
  LDBL_EPSILON := one;
  repeat
    LDBL_EPSILON := LDBL_EPSILON / 2;
    tmp := LDBL_EPSILON + one;
  until tmp = one;
  LDBL_EPSILON := LDBL_EPSILON * 2;           // extended LDBL_EPSILON := 2^(1-64)
  memo1.Clear;
  memo1.Lines.Append('PAQȉ~ϕ');
end;

end.
